<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2021 Amasty (https://www.amasty.com)
 * @package Amasty_Checkout
 */
?>
<?php /** @var $block \Magento\Checkout\Block\Onepage\Success */ ?>
<div class="checkout-success">
    <?php if ($block->getOrderId()) : ?>
        <div class="success-messages">
            <?php if ($block->getCanViewOrder()) : ?>
                <p><?= $block->escapeHtml(__('Your order number is:')) ?>
                    <a href="<?= /* @noEscape */
                    $block->getViewOrderUrl() ?>"
                       class="order-number">
                        <strong>
                            <?= /* @noEscape */
                            $block->getOrderId() ?>
                        </strong>
                    </a>
                </p>
            <?php else : ?>
                <p>
                    <?= $block->escapeHtml(__('Your order # is:')) ?>
                    <span>
                        <?= /* @noEscape */
                        $block->getOrderId() ?>
                    </span>
                </p>
            <?php endif; ?>
            <p><?= $block->escapeHtml(__('We\'ll email you an order confirmation with details and tracking info.')) ?></p>
        </div>
        <?= $block->getChildHtml('details') ?>
    <?php endif; ?>

    <?= $block->getAdditionalInfoHtml() ?>
    <?= $block->getChildHtml('cms') ?>

    <div class="actions-toolbar">
        <div class="primary">
            <a class="action primary continue btn btn-secondary" href="<?= /* @noEscape */
            $block->getUrl() ?>">
                <span><?= $block->escapeHtml(__('Continue Shopping')) ?></span>
            </a>
        </div>
    </div>
</div>
<?php

$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
$json = $objectManager->create('Magento\Framework\Serialize\Serializer\Json');

$purchase = [];
$order = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')
    ->loadByIncrementId($block->getOrderId());
$store_name = $order->getData('store_name');
$discount_amount = $order->getData('discount_amount');
$affiliation = 'Google Merchandise Store';
$value = $order->getBaseGrandTotal();
$transaction_id = $block->getOrderId();
$tax_amount = $order->getData('tax_amount');
$shipping = $order->getData('shipping');
$currency = $order->getOrderCurrencyCode();
$coupon_code = $order->getData('coupon_code');
$items = [];

$purchase['event'] = 'purchase';

$j = 0;
foreach ($order->getAllVisibleItems() as $_item) {

    $items[$j] = [
        'item_id' => $_item->getSku(),
        'item_name' => $_item->getName(),
        'affiliation' => $affiliation,
        'discount_amount' => $_item->getData('discount_amount'),
        'currency' => $currency,
        'coupon' => $coupon_code,
        'price' => $_item->getData('price'),
        'quantity' => $_item->getQtyOrdered(),
        'index' => $j
    ];
    $_product = $objectManager->create('Magento\Catalog\Model\Product')
        ->load($_item->getProductId());
    $categoryIds = $_product->getCategoryIds();

    $i = 0;
    $categories = [];

    if (count($categoryIds)) {
        foreach ($categoryIds as $categoryId) {
            $i++;
            $category = $objectManager->create('Magento\Catalog\Model\Category')
                ->load($categoryId);

            if ($i == 1) {
                $item_category = 'item_category';
            } else {
                $item_category = 'item_category' . $i;
            }
            $items[$j][$item_category] = $category->getName();
        }
    }
    $j++;
}

$orderData = [
    'transaction_id' => $transaction_id,
    'affiliation' => $affiliation,
    'value' => $value,
    'tax' => $tax_amount,
    'shipping' => $shipping,
    'currency' => $currency,
    'coupon' => $coupon_code,
    'items' => $items
];
$purchase['ecommerce'] = $orderData;
echo $json_data = $json->serialize($purchase); // it's same as like json_encode

?>
<?php
if (strpos($store_name, 'USA') !== false) { ?>
    <?php
    $pixelValue = number_format($order->getBaseGrandTotal(), 2);
    $pixelCurrency = $order->getOrderCurrencyCode();
    ?>

    <script type="text/javascript">
        window.dataLayer = window.dataLayer || [];        
        window.dataLayer.push({ecommerce: null});  // Clear the previous ecommerce object.
        window.dataLayer.push(<?php echo $json_data; ?>);
    </script>
<?php } ?>
